package com.example.ellegadodepintia.exploradoresDePintia

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.graphics.Color
import android.graphics.drawable.AnimationDrawable
import android.os.Bundle
import android.widget.ImageButton
import android.widget.ImageView
import android.widget.Toast
import androidx.activity.result.ActivityResultLauncher
import androidx.activity.result.contract.ActivityResultContracts
import androidx.appcompat.app.AppCompatActivity
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState

import com.example.ellegadodepintia.exploradoresDePintia.model.GeneradorDeEventos
import com.example.ellegadodepintia.exploradoresDePintia.model.LayoutUtils
import com.example.ellegadodepintia.exploradoresDePintia.model.GestorDeEventos
import java.lang.ref.WeakReference

class ExploradoresDePintia : AppCompatActivity() {
    private var dificultad = 0
    private lateinit var startForResult: ActivityResultLauncher<Intent>


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_exploradores_de_pintia)

        startForResult = registerForActivityResult(ActivityResultContracts.StartActivityForResult()) { result ->
            if (result.resultCode == Activity.RESULT_OK) {
                val mensajeResultado = result.data?.getStringExtra("resultado")
                println("Volvemos del mini-juego: $mensajeResultado")
            }
        }

        GameState.fragmentManager = supportFragmentManager

        GeneradorDeEventos.generarEventos()

        GameState.setContexto(WeakReference<Context>(this))

        val inventoryButton: ImageButton = findViewById(R.id.inventoryButton)
        val eventButton: ImageButton = findViewById(R.id.eventButton)

        eventButton.setBackgroundResource(R.drawable.style_texto_border)
        inventoryButton.setBackgroundColor(Color.TRANSPARENT)

        inventoryButton.setOnClickListener {
            val inventarioFragment = InventoryMain()
            inventarioFragment.show(supportFragmentManager, "inventario")
        }

        val imagenProtagonista = findViewById<ImageView>(R.id.imagenProtagonista)
        val idleAnimation = imagenProtagonista.drawable as? AnimationDrawable
        idleAnimation?.start()

        iniciarJuego()
    }

    private fun iniciarJuego() {
        GameState.jugador.addObserver {
            LayoutUtils.actualizarEstadisticasMain()
            LayoutUtils.actualizarMonedas()
        }
        LayoutUtils.actualizarEstadisticasMain()
        LayoutUtils.actualizarMonedas()
        GeneradorDeEventos.generarEvento(dificultad)
        GestorDeEventos.gestionar()
    }

    @Deprecated("Deprecated in Java")
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == 100 && resultCode == RESULT_OK) {
            val resultado = data?.getStringExtra("resultado")
            Toast.makeText(this, resultado, Toast.LENGTH_SHORT).show()
            // Aquí puedes realizar acciones según el resultado
        }
    }


}
