package com.example.ellegadodepintia.exploradoresDePintia

import android.animation.AnimatorSet
import android.animation.ObjectAnimator
import android.content.Intent
import android.os.Bundle
import android.view.animation.AccelerateDecelerateInterpolator
import android.widget.Button
import android.widget.ImageView
import android.widget.ProgressBar
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.example.ellegadodepintia.MapActivity
import com.example.ellegadodepintia.R
import com.example.ellegadodepintia.exploradoresDePintia.model.Atributo
import com.example.ellegadodepintia.exploradoresDePintia.model.GameState
import com.example.ellegadodepintia.exploradoresDePintia.model.objeto.ObjetoDeValor

class Resumen : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_resumen_partida)
        if(GameState.jugador.atributos[Atributo.Vida]!! <= 0){
            mostrarDerrota()
        } else {
            calcularGanancias()
        }
        GameState.jugador.monedas.toString()
            .also { findViewById<TextView>(R.id.moneyText).text = it }

        val continuarButton = findViewById<Button>(R.id.botonContinuar)
        continuarButton.setOnClickListener {
            val intent = Intent(this, MapActivity::class.java)
            startActivity(intent)
            GameState.reset()
        }

        val barraVida = findViewById<ProgressBar>(R.id.barraVida)
        barraVida.max = GameState.jugador.vidaMax
        barraVida.progress = GameState.jugador.atributos[Atributo.Vida]!!
    }

    private fun mostrarDerrota(){
        val textoResumen = findViewById<TextView>(R.id.textoResumen)
        val imagenProtagonista = findViewById<ImageView>(R.id.imagenProtagonista)

        "El investigador ha sido derrotado, ha perdido todos sus objetos del inventario".also { textoResumen?.text = it }
        imagenProtagonista?.setImageResource(R.drawable.protagonista_die_06)

    }

    private fun calcularGanancias() {
        val imagenProtagonista = findViewById<ImageView>(R.id.imagenProtagonista)
        val textoResumen = findViewById<TextView>(R.id.textoResumen)
        val recyclerView: RecyclerView = findViewById(R.id.resumenRecyclerView)
        recyclerView.layoutManager = LinearLayoutManager(this)
        var nObjetosValor = 0
        textoResumen?.text = ""

        val movimientoLateral = ObjectAnimator.ofFloat(imagenProtagonista, "translationX", -100f, 100f)
        movimientoLateral.duration = 1500
        movimientoLateral.repeatCount = ObjectAnimator.INFINITE
        movimientoLateral.repeatMode = ObjectAnimator.REVERSE

        val reboteVertical = ObjectAnimator.ofFloat(imagenProtagonista, "translationY", 0f, 30f, 0f)
        reboteVertical.duration = 600
        reboteVertical.repeatCount = ObjectAnimator.INFINITE
        reboteVertical.repeatMode = ObjectAnimator.REVERSE
        reboteVertical.interpolator = AccelerateDecelerateInterpolator()

        val animatorSet = AnimatorSet()
        animatorSet.playTogether(movimientoLateral, reboteVertical)
        animatorSet.start()

        val objetosDeValor: MutableList<ObjetoDeValor> = mutableListOf()
        for (objeto in GameState.jugador.inventario) {
            if (objeto is ObjetoDeValor) {
                nObjetosValor++
                objetosDeValor.add(objeto)
                objeto.usar()
            }
        }
        println(objetosDeValor.isEmpty())
        recyclerView.adapter = ResumenAdapter(objetosDeValor)


        if (nObjetosValor == 0) {
            "El investigador no ha conseguido ningún objeto de valor".also { textoResumen?.text = it }
        } else {
            "${textoResumen.text} Enhorabuena, has conseguido ${nObjetosValor*20} monedas.".also {
                textoResumen.text = it
            }

        }
    }
}